﻿/**
 * レイヤーごとにレイヤー名に合わせてPNGに書き出す
 */

// #target photoshop

// 処理開始

if( app.documents.length == 0 ){
    alert( "【！】実行するドキュメントがありません。" );
} else {
    if( confirm( "処理を開始します。よろしいですか？" ) ){
        main();
    } else {
        alert( "【！】キャンセルされました" );
    }
}

function main(){
    // すべてオフ（レイヤーのみ）
    allHiddenLayerSetsList( activeDocument  );
    // レイヤーを一つ一つオンにしてPNG保存
    visibleLayerAndPNG( activeDocument );
    alert( "すべての処理が完了しました。お疲れ様でした。" );
}


// PNG保存部分
function pngSave( filename ){
    var pngOptions = new PNGSaveOptions();
    var filepath = activeDocument.path + "/" + filename;
    $.writeln ( "resizePNGSave [" + i + "] > file : " + filepath );
    activeDocument.saveAs( File( filepath ), pngOptions, true, Extension.LOWERCASE );
}

// レイヤーを一つ一つオンにしてPNG保存
function visibleLayerAndPNG( layer ){
    for (var i=0; i<layer.artLayers.length; i++){
        layer.artLayers[i].visible = true;
        pngSave(layer.artLayers[i].name);
        layer.artLayers[i].visible = false;
    }
    for (var i=0; i<layer.layerSets.length; i++){
        visibleLayerAndPNG(layer.layerSets[i]);
    }
}

// すべてオフ（レイヤーのみ）
function allHiddenLayerSetsList( layer ){
    for (var i=0; i<layer.artLayers.length; i++){
        layer.artLayers[i].visible = false;
    }
    for (var i=0; i<layer.layerSets.length; i++){
        allHiddenLayerSetsList(layer.layerSets[i]);
    }
}

